const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const motivoProrroPage = require('../../../page-objects/parametrizacao/financeiro/motivoProrrogacao.po.js');

const motivoProrroGridId = '11150281673076389010215';

describe('Tela Motivo de Prorrogação', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		motivoProrroPage.abrir();
		geral.clickAplicarFiltro();
		protractorHelper.waitForElementVisibility(
			element(by.id(`grid-${motivoProrroGridId}`)), 5000);
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar tela Motivo de Prorrogação', () => {
		expect(z.component.header.getTitle()).toBe('Motivo de Prorrogação');
	});

	it('Adicionar uma Motivo de Prorrogação', () => {
		geral.clickAdicionar();
		motivoProrroPage.adicionar(j.getValor('codigoMotivoProrro'), j.getValor('descricaoMotivoProrro'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('codigoMotivoProrro'));

		expect(geral.gridHasText(motivoProrroGridId, j.getValor('descricaoMotivoProrro'), 1))
			.toBe(j.getValor('descricaoMotivoProrro'));
		expect(geral.gridHasText(motivoProrroGridId, j.getValor('codigoMotivoProrro')))
			.toBe(j.getValor('codigoMotivoProrro'));
	});

	it('Editar registro', () => {
		geral.filterIt(j.getValor('codigoMotivoProrro'));
		geral.clickGrid('DSMOTIPROR', j.getValor('descricaoMotivoProrro'), motivoProrroGridId);
		geral.clickEditar();
		motivoProrroPage.editar(j.getValor('descricaoMotivoProrro1'));
		geral.clickSalvar();
		geral.clickVoltar();
		geral.filterIt(j.getValor('codigoMotivoProrro'));

		expect(geral.gridHasText(motivoProrroGridId, j.getValor('descricaoMotivoProrro1'), 1))
			.toBe(j.getValor('descricaoMotivoProrro1'));
		expect(geral.gridHasText(motivoProrroGridId, j.getValor('codigoMotivoProrro')))
			.toBe(j.getValor('codigoMotivoProrro'));
	});

	it('Excluir registro', () => {
		geral.filterIt(j.getValor('codigoMotivoProrro'));
		geral.clickGrid('DSMOTIPROR', j.getValor('descricaoMotivoProrro1'), motivoProrroGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(motivoProrroGridId, j.getValor('descricaoMotivoProrro1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(motivoProrroGridId, j.getValor('codigoMotivoProrro')))
			.toBeUndefined();
	});
});
